package com.example.gesmec;


import java.util.Vector;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

/*
 * Gestion de la base de datos local.
 * Actualmente solo se utiliza la consulta a la tabla Servidor, campo IP.
 * Se deja la gestion ya que dentro de  las lineas abiertas de este proyecto
 * queda reflejada la posibilidad de realizar consultas a diversas tablas de una base de datos
 * alojada en el terminal, en vez de realizar multiples consultas
 */

public class BDgesmec  extends SQLiteOpenHelper{
	 
	private static final String DATABASE_NAME = "bbdd_gesmec.db";
	private static final int DATABASE_VERSION = 1;
	
	 
	  public BDgesmec(Context ctx) {
	    super(ctx, DATABASE_NAME, null, DATABASE_VERSION);
	  }

	  @Override
	  public void onCreate(SQLiteDatabase db) {
	    db.execSQL("CREATE TABLE usuarios (id INTEGER PRIMARY KEY AUTOINCREMENT, nombre TEXT NOT NULL, contrasena TEXT NOT NULL," +
	    		" direccion TEXT, localidad TEXT, correoelectronico TEXT, numero_tarjeta TEXT, id_servicio_medico INTEGER);");
	    db.execSQL("CREATE TABLE servicio_medico (id INTEGER PRIMARY KEY AUTOINCREMENT, nombre TEXT NOT NULL, " +
	    		"cif TEXT, razon_social TEXT);");
	    db.execSQL("CREATE TABLE centros_medicos (id INTEGER PRIMARY KEY AUTOINCREMENT, nombre TEXT NOT NULL, " +
	    		"direccion TEXT, telefono TEXT, longitud TEX, latitud TEXT, localidad TEXT, " +
	    		"codigo_postal TEXT, observaciones TEXT, id_servicio_medico INTEGER);");
	    db.execSQL("CREATE TABLE medicos (id_centro_medico , id INTEGER PRIMARY KEY, nombre , " +
	    		"id_especialidad NUMERIC, numerocarnet TEXT);");
	    db.execSQL("CREATE TABLE horario (id INTEGER PRIMARY KEY, id_medico NUMERIC, id_fecha NUMERIC, id_hora , estado TEXT);");
	    db.execSQL("CREATE TABLE cita (id INTEGER PRIMARY KEY, id_usuario NUMERIC, id_horario NUMERIC, observaciones TEXT);");
	    db.execSQL("CREATE TABLE especialidades (id INTEGER PRIMARY KEY, nombre TEXT, otros TEXT);");
	    db.execSQL("CREATE TABLE servidor ( IP TEXT);");
	    
	  }

	  @Override
	  public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
	    db.execSQL("DROP TABLE IF EXISTS usuarios");
	    db.execSQL("DROP TABLE IF EXISTS servicio_medico");
	    db.execSQL("DROP TABLE IF EXISTS centros_medicos");
	    db.execSQL("DROP TABLE IF EXISTS medicos");
	    db.execSQL("DROP TABLE IF EXISTS horario");
	    db.execSQL("DROP TABLE IF EXISTS cita");
	    db.execSQL("DROP TABLE IF EXISTS especialidades");
	    
	    
	    
	    onCreate(db);
	  }
	  
	  public void addUsuServer(OUsuario v_ousuario) {
			SQLiteDatabase  db = getWritableDatabase();
		    ContentValues values = new ContentValues();
		    
		    values.put("nombre", v_ousuario.getnombre());
		    values.put("contrasena", v_ousuario.getcontrasena());
		    values.put("direccion", v_ousuario.getdireccion());
		    values.put("localidad", v_ousuario.getlocalidad());
		    values.put("correoelectronico", v_ousuario.getcorreoelectronico() );
		    values.put("numero_tarjeta", v_ousuario.getnumero_tarjeta() );
		    values.put("id_servicio_medico", v_ousuario.getid_servicio_medico());
		    try 
			  {
		    	db.insertOrThrow("usuarios", null, values);
			  }
			  catch (Exception e) 
			  {
				  Log.e("addUsuServer", "error en insercion");
			  }
			  db.close();
		  
		  }
	  
	  public OUsuario getUsuServer (long v_id, String v_nombre, String v_pass) {
		 	  
		  OUsuario ousuario = new OUsuario();
		  SQLiteDatabase db = getReadableDatabase();
		  String select;
		  try 
		  {
				if (v_id == 0)
				{
					 select = "Select ID, NOMBRE, CONTRASENA,DIRECCION, CORREOELECTRONICO, LOCALIDAD, NUMERO_TARJETA,ID_SERVICIO_MEDICO from usuarios where nombre like '%"+v_nombre+"%' and contrasena='"+v_pass+"'";    	
				}
				else
				{
					 select = "Select ID, NOMBRE, CONTRASENA,DIRECCION, CORREOELECTRONICO, LOCALIDAD, NUMERO_TARJETA,ID_SERVICIO_MEDICO from usuarios where id='"+v_id+"'";    	
					
				}
				Cursor c = db.rawQuery(select, null);
				if (c.getCount() == 1) 	
				{  
					c.moveToFirst();
					long id = c.getLong(0);
			  	      String usu = c.getString(1);
			  	      String pass = c.getString(2);
			  	      String direc = c.getString(3);
				      String loca = c.getString(4);
				      String corr =c.getString(5);
				      String tarj= c.getString(6);
				      long idme= c.getLong(7);
			  	      
			  	      ousuario.setid(id);
			  		  ousuario.setnombre(usu);
			  		  ousuario.secontrasena(pass);
			  		  ousuario.setdireccion(direc);
			  		  ousuario.setlocalidad(loca);
			  		  ousuario.setcorreoelectronico(corr);
			  		  ousuario.setnumero_tarjeta(tarj);
			  		  ousuario.setid_servicio_medico(idme);
			  		  return ousuario;    	    
				} 
				else 
				{
					return null;
				}
						 
		  }
		  catch (Exception e) 
		  {
			  Log.e("getUsuServer", "error en consulta");
		  }
		  db.close();
		  return ousuario;
		 
	 } 
	  
	  public void ModUsu(OUsuario v_ousuario, long v_idusuario) {
			SQLiteDatabase  db = getWritableDatabase();
			
			String update = "UPDATE usuarios SET NOMBRE='"+v_ousuario.getnombre()+"', CONTRASENA='"+v_ousuario.getcontrasena()+"',DIRECCION='"+v_ousuario.getdireccion()+"', CORREOELECTRONICO='"+v_ousuario.getcorreoelectronico()+"', " +
					"LOCALIDAD='"+v_ousuario.getlocalidad()+"', NUMERO_TARJETA='"+v_ousuario.getnumero_tarjeta()+"',ID_SERVICIO_MEDICO='"+v_ousuario.getid_servicio_medico()+"' WHERE id='"+v_idusuario+"'";
		    db.execSQL(update);
			db.close();
		  }
	  
	  public void DelUsu(long v_idusuario) {
		SQLiteDatabase  db = getWritableDatabase();
		try 
			  {	
			String delete = "delete from usuarios where id='"+v_idusuario+"'";    	
			db.execSQL(delete);
		  }
		  catch (Exception e) 
		  {
			  Log.e("DelUsu", "error en la ejecucion delete");
		  }
		  db.close();
	}
	
	  public Vector<OServicio> getSerServer() {
			Vector<OServicio> Vobjetoservicio = new Vector<OServicio>();
		    SQLiteDatabase db = getReadableDatabase();
		    try 
			  {
					String select = "Select id, nombre , cif , razon_social from servicio_medico order by id";    	
					Cursor c = db.rawQuery(select, null);
				
					if (c.getCount() > 0) 	
					{  
						while (c.moveToNext()) 
						{
							OServicio servicio = new OServicio();
						      servicio.setid(c.getLong(0));
						      servicio.setnombre(c.getString(1));
						      servicio.setcif(c.getString(2));
						      servicio.setrazon_social(c.getString(3));
						      Vobjetoservicio.add(servicio);
						      
						}
					
					}
					else
					{
						return null;
					}
					
					
				}
				catch (Exception e) 
				{
					Log.e("getSerServer", "error en consulta");
				}
				db.close();
				return Vobjetoservicio;
	  }  
	  
	  
	  public  Vector<OCentromedico> getVectCenServer(long v_idmedicos) {
			
		  	Vector<OCentromedico> Vcentromedico = new Vector<OCentromedico>();
			SQLiteDatabase db = getReadableDatabase();
		 	String select;
		 	
		 	try
		 	{
		 	select = "SELECT id , nombre, direccion,telefono, longitud, latitud, codigo_postal, observaciones,id_servicio_medico FROM centros_medicos WHERE id_servicio_medico = '"+v_idmedicos+"' order by nombre";
		 	
		 	Cursor c = db.rawQuery(select, null);
		
		 	if (c.getCount() > 0) 	
			{  

				while (c.moveToNext()) {
					long id = c.getLong(0);
				  	String nombre = c.getString(1);
				  	String direc = c.getString(2);
				  	String telf = c.getString(3);
				  	String longitud = c.getString(4);
					String latitud = c.getString(5);
					String codpostal =c.getString(6);
					String observ= c.getString(7);
					long id_servicio_medico= c.getLong(8);
					
					
					OCentromedico ocentromedico = new OCentromedico();
					
					ocentromedico.setid(id);
					ocentromedico.setnombre(nombre);
				  	ocentromedico.setdireccion(direc);
				  	ocentromedico.settelefono(telf);
				  	ocentromedico.setlongitud(longitud);
				  	ocentromedico.setlatitud(latitud);
				  	ocentromedico.setcodigo_postal(codpostal);
				  	ocentromedico.setobservaciones(observ);
				  	ocentromedico.setservicio_medico(id_servicio_medico);
				  	
				  	Vcentromedico.add(ocentromedico);
				  		
					}
				
				}
				else
				{
					return null;
				}
			 }
			catch (Exception e) 
			{
				Log.e("getVectCenServer", "error en consulta");
			}
			db.close();
			return Vcentromedico;
		    
	 }
	  
	  
	  
	  
	  public OCentromedico getCenServer(long v_idcentromedico) {
		  OCentromedico ocentromedico = new OCentromedico();
		  SQLiteDatabase db = getReadableDatabase();
		  String select;
		 try
		 {
		 	select = "SELECT id , nombre, direccion,telefono, longitud, latitud, codigo_postal, observaciones,id_servicio_medico FROM centros_medicos WHERE id = '"+v_idcentromedico+"'";
		 	
		 	Cursor c = db.rawQuery(select, null);
		
		 	if (c.getCount() == 1) 	
			{  
				c.moveToFirst();
					long id = c.getLong(0);
				  	String nombre = c.getString(1);
				  	String direc = c.getString(2);
				  	String telf = c.getString(3);
				  	String longitud = c.getString(4);
					String latitud = c.getString(5);
					String codpostal =c.getString(6);
					String observ= c.getString(7);
					long id_servicio_medico= c.getLong(8);
					
					
					
					ocentromedico.setid(id);
					ocentromedico.setnombre(nombre);
				  	ocentromedico.setdireccion(direc);
				  	ocentromedico.settelefono(telf);
				  	ocentromedico.setlongitud(longitud);
				  	ocentromedico.setlatitud(latitud);
				  	ocentromedico.setcodigo_postal(codpostal);
				  	ocentromedico.setobservaciones(observ);
				  	ocentromedico.setservicio_medico(id_servicio_medico);
				  	
			 		  return ocentromedico;    	    
					} 
							else 
							{
								return null;
							}
		}
	  catch (Exception e) 
	  {
		  Log.e("getCenServer", "error en consulta");
	  }
	  db.close();
	  return ocentromedico;
					
		    
	 }
	
	  public  Vector<OMedico> getVecMedCenEspServer(long v_id_centro_medico, long v_id_especialidad) {
		  
		  	Vector<OMedico> VMedicos = new Vector<OMedico>();
			SQLiteDatabase db = getReadableDatabase();
		 	String select;
		 	
		 	try
		 	{
		 	select = "SELECT id , nombre, numerocarnet,id_especialidad, id_centro_medico FROM medicos WHERE id_centro_medico = '"+v_id_centro_medico+"' and id_especialidad = '"+v_id_especialidad+"'";
		 	
		 	Cursor c = db.rawQuery(select, null);
		
		 	if (c.getCount() > 0) 	
			{  

				while (c.moveToNext()) {
					long id = c.getLong(0);
				  	String nombre = c.getString(1);
				  	String numerocarnet = c.getString(2);
				  	long id_especialidad= c.getLong(3);
					long id_centro_medico= c.getLong(4);
					
					
					OMedico omedicos = new OMedico();
					
					omedicos.setid(id);
					omedicos.setnombre(nombre);
					omedicos.setnumerocarnet(numerocarnet);
				 	omedicos.setid_especialidad(id_especialidad);
					omedicos.setid_centro_medico(id_centro_medico);
				  	VMedicos.add(omedicos);
				  		
					}
				
				}
				else
				{
					return null;
				}
			 }
			catch (Exception e) 
			{
				Log.e("getVecMedCenEspServer", "error en consulta");
			}
			db.close();
			return VMedicos;
		    
	 }


	  public  Vector<OEspecialidad> getVecEspMedServer(long v_id_centro_medico) {
		  
		  	Vector<OEspecialidad> Vespecialidad = new Vector<OEspecialidad>();
			SQLiteDatabase db = getReadableDatabase();
		 	String select;
		 	
		 	try
		 	{
		 	select = "select id, nombre, otros from especialidades where id in (select id_especialidad from medicos where id_centro_medico='"+v_id_centro_medico+"')";
		 	
		 	Cursor c = db.rawQuery(select, null);
		
		 	if (c.getCount() > 0) 	
			{  

				while (c.moveToNext()) {
					long id = c.getLong(0);
				  	String nombre = c.getString(1);
				  	String otros = c.getString(2);
					
					OEspecialidad oespecialidad = new OEspecialidad();
					
					oespecialidad.setid(id);
					oespecialidad.setnombre(nombre);
					oespecialidad.setotros(otros);
				  	Vespecialidad.add(oespecialidad);
				  		
					}
				
				}
				else
				{
					return null;
				}
			 }
			catch (Exception e) 
			{
				Log.e("getVecEspMedServer", "error en consulta");
			}
			db.close();
			return Vespecialidad;
		    
	 }
	  
	  public Vector<OHorario> getHorarioServer(long v_id_medico, long v_dia, long v_mes, long v_ano) {
			Vector<OHorario> Vobjetohorario = new Vector<OHorario>();
		    SQLiteDatabase db = getReadableDatabase();
		    String s_mes2="";
		    String s_mes = String.valueOf(v_mes);
		    
		    if (s_mes.length() ==1){s_mes2='0'+s_mes;} else {s_mes2 = s_mes;}
		    
		    try 
			  {
					String select = "Select id, id_medico , id_fecha , id_hora, estado from horario where id_medico='"+v_id_medico+"' and id_fecha like'%"+v_ano+"%"+s_mes2+"%"+v_dia+"%'"; 	
					
					Cursor c = db.rawQuery(select, null);
				
					if (c.getCount() > 0) 	
					{  
						while (c.moveToNext()) 
						{
							OHorario ohorario = new OHorario();
							ohorario.setid(c.getLong(0));
							ohorario.setid_medico(c.getLong(1));
							ohorario.setid_fecha(c.getLong(2));
							ohorario.setid_hora(c.getLong(3));
							ohorario.setestado(c.getInt(4));
						    Vobjetohorario.add(ohorario);
						      
						}
					
					}
					else
					{
						return null;
					}
					
					
				}
				catch (Exception e) 
				{
					Log.e("getHorarioServer", "error en consulta");
				}
				db.close();
				return Vobjetohorario;
	  }  
	  
	  
	  public void ModHorarioServer(long v_idhorario, long v_estado) {
			SQLiteDatabase  db = getWritableDatabase();
			try 
			  {
				String update = "UPDATE horario SET ESTADO='"+v_estado+"' WHERE id='"+v_idhorario+"'";
			    db.execSQL(update);
			  }
			  catch (Exception e) 
			  {
				  Log.e("ModHorarioServer", "error en consulta");
			  }
			  db.close();
			
		  }
	  
	  public void addCitaServer(OCita ocita) {
			SQLiteDatabase  db = getWritableDatabase();
		    ContentValues values = new ContentValues();
		    
		    values.put("id_usuario", ocita.getid_usuario());
		    values.put("id_horario", ocita.getid_horario());
		    values.put("observaciones", ocita.getobservaciones());
		    
		    try 
			  {
		    	db.insertOrThrow("cita", null, values);
			  }
			  catch (Exception e) 
			  {
				  Log.e("addCitaServer", "error en consulta");
			  }
			  db.close();
		  
		  }
	  public Vector<OCita> getListaCitaServer(long v_id_usuario) {
			Vector<OCita> Vcita = new Vector<OCita>();
		    SQLiteDatabase db = getReadableDatabase();
		    try 
			  {
					String select = "select c.id, m.nombre, h.id_fecha, h.id_hora, c.observaciones from medicos m , horario h,  cita c where c.id_horario = h.id and h.id_medico=m.id and c.id_usuario='"+v_id_usuario+"'"; 	
					
					Cursor c = db.rawQuery(select, null);
				
					if (c.getCount() > 0) 	
					{  
						while (c.moveToNext()) 
						{
							OCita ocita = new OCita();
							ocita.setid(c.getLong(0));
							ocita.setnombre_medico(c.getString(1));
							ocita.setid_fecha(c.getLong(2));
							ocita.setid_hora(c.getLong(3));
							Vcita.add(ocita);
						      
						}
					
					}
					else
					{
						return null;
					}
					
					
				}
				catch (Exception e) 
				{
					Log.e("getListaCitaServer", "error en consulta");
				}
				db.close();
				return Vcita;
	  }  
	  
	  public String dameIPconfiguracion () {
	 	  
		 
	
		  String IP="";
		  String select ="";
		  SQLiteDatabase db = getReadableDatabase();
		  try 
		  {
			  select = "Select IP from servidor ";    	
					
				Cursor c = db.rawQuery(select, null);
				
				if (c.getCount() == 1) 	
				{  
					c.moveToFirst();
					IP = c.getString(0);
				} 
				else 
				{
			 	   IP=null;
				}
						 
		  }
		  catch (Exception e) 
		  {
			  Log.e("dameIPconfiguracion", "error en consulta");
		  }
		  db.close();
		  Log.i("dameIPconfiguracion", "IP DENTRO GEST "+IP);	
		  return IP;
		 
	 } 
	
}
