package com.example.gesmec;

import java.util.ArrayList;
import java.util.Vector;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.app.Activity;
import android.widget.Button;
import android.content.Context;
import android.content.Intent;
import org.json.JSONException;
/*
 * seleccion del listado de horario, en el cual se muestra la si la hora esta ocupada/libre
 */
public class Calendario extends Activity {
	String Seleccion="";
	long idrecupera;
	ListView list;
	ListView listE;
	JSONParser json4 = new JSONParser(this);
	boolean conexion;
	TextView informacion;
	
	Vector<OHorario> Vhorario= new Vector<OHorario>();
	
	int dia, mes, ano;
	int hora, minuto;
	  
	String r_id_nombre, r_nombre_medico;
	long r_id_medicos, r_id_usuario, r_id_centro_medicos, r_id_especialidad, r_id_medico;
	
	public boolean isOnline() {
		// Comprueba si tiene servicio de conexion 
		 ConnectivityManager cm = 
		         (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo netInfo = cm.getActiveNetworkInfo();
		    if (netInfo != null && netInfo.isConnected()) {
		        return true;
		    }
		    return false;
		
	}
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.calendario);
		Bundle datos = getIntent().getExtras ();
		//recuperamos los datos enviados desde la clase Selcita
		if (datos != null)
		{
			r_id_usuario = datos.getLong("usuario_id");
			r_id_nombre= datos.getString("usuario_nombre");
			r_id_medicos = datos.getLong("usuario_id_servicio_medico");
			r_id_medico= datos.getLong("medico_id");
			r_nombre_medico = datos.getString("medico_nombre");
			dia = datos.getInt("dia");
			mes = datos.getInt("mes");
			ano = datos.getInt("ano");
			
		}
		
		list = (ListView)findViewById(R.id.calhorario_LT_horamedicos);
		
		//Cargamos un array con la consulta generada
		ArrayList<String> items = new ArrayList<String>();
		String valor="";
		informacion = (TextView) findViewById(R.id.calendario_T_informacion);
		conexion = isOnline();
		if (conexion == true)
    	{
   	 		//mostramos informacion
   	 		informacion.setText("CONEXION DE DATOS - CORRECTA");

		try {
			
			Vhorario=json4.readAndParseJSONgetHorarioServer(r_id_medico, dia, mes, ano);
			
			
		} catch (JSONException e) {
			Log.e("Calendario", "error"+e.toString());
			e.printStackTrace();
		}
		
				
		if (Vhorario != null)
		{
		      for( int i=0; i<Vhorario.size() ; i ++ ){ 
		    	  OHorario horario = new OHorario();
		    	  horario = Vhorario.elementAt(i); 
		    	  //parseamos los valores de la base de datos, estado y fecha, para la correcta visualizacion
		    	  if (horario.getestado() == 0)
		    			valor="libre";
		    			else
		    			valor="ocupado";
		    				
		    	  	String s_hora= String.valueOf(horario.getid_hora());
		    		String s_formateohora="";
				   if (s_hora.length() ==3)
				   {s_formateohora='0'+s_hora.substring(0, 1)+':'+s_hora.substring(1, 3);} 
				   else 
				   {
					   if (s_hora.length() == 4){
						   s_formateohora=s_hora.substring(0, 2)+':'+s_hora.substring(2, 4);} 
					   
					   else{
							Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR FORMATO HORA ", Toast.LENGTH_LONG);
							toast2.show();
							Log.e("Calendario", "error formato de  hora incorrecto");
							
					   }
					   
				   }
				  
        			items.add(s_formateohora+"					"+valor);
        			} 
		}
		else
		{
				Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN HORARIO \n Tabla vacia o inexistente", Toast.LENGTH_LONG);
				toast2.show();
				Log.e("Calendario", "error en la tabla de horario");
				finish();
				Intent myIntent = new Intent(Calendario.this, Selhorario.class);
				myIntent.putExtra("usuario_id",r_id_usuario);
		        myIntent.putExtra("usuario_nombre",r_id_nombre );
		        myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        myIntent.putExtra("medico_id",r_id_medico );
		        myIntent.putExtra("centro_nombre",r_id_centro_medicos );
			    myIntent.putExtra("medico_nombre",r_nombre_medico );				
				startActivityForResult(myIntent, 0);
	 	}
 		
		
		//carga el cuadro de texto con la lista
	    list.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_dropdown_item_1line, items));    
	    list.setClickable(true);
	    list.setOnItemClickListener(new AdapterView.OnItemClickListener() {

	      @Override
	      public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {
	    	  String FechaFor="";
	    	  Object e = list.getItemAtPosition(position);
	    	  if (e.toString().contains("ocupado"))
		      {
		    	  Toast toast2 = Toast.makeText(getApplicationContext(), "HORA OCUPADA \n SELECCIONE UNA HORA LIBRE", Toast.LENGTH_SHORT);
					toast2.show();
					Log.i("Calendario", "informacion: Hora ocupada");
					
		      }
		      else
		      {
		    	  Object o = list.getItemAtPosition(position);
		    	  FechaFor = o.toString().substring(0,5);
		    	  	String s_hora="";
				  	if (o.toString().substring(0, 1).toString().equals( "0"))
		    	 	{
		    	  		s_hora=o.toString().substring(1, 2);
		    	    	  
		    	 	}
		    	 	else
		    	 	{
		    	 		s_hora=o.toString().substring(0, 2);
				    	 		
		    	 	}
		    	  	String s_min = o.toString().substring(3, 5);
		    	  	String s_horalim= s_hora+s_min;
		    	  
		    	  for( int i=0; i<Vhorario.size() ; i ++ ){ 
			    	  OHorario horario = new OHorario();
			    	  horario = Vhorario.elementAt(i); 
			    	  String formatea= String.valueOf(horario.getid_hora());	  
			    	  if (formatea.toString().equals( s_horalim))
			    	  {  
			    		  	  
			    		r_id_centro_medicos = horario.getid();
			    	  	OCita ocita= new OCita();
			    	  	ocita.setid_horario(horario.getid());
			    	  	ocita.setid_usuario(r_id_usuario);
			    	  	ocita.setobservaciones("0");
	      				
			    	  	//incluimos la cita para ese usuario y horario
			    	  	json4.readAndParseJSONsetCitaServer(ocita);
			    	  	//modificamos elhorario del medico, como ocupado
			    		json4.readAndParseJSONsetUpdateHorarioServer(horario.getid(), 1);
	      				
	      				Toast toast2 = Toast.makeText(getApplicationContext(), "CITA REALIZADA \n " +
	      						"MEDICO: "+r_nombre_medico+" DIA: "+dia+"/"+mes+"/"+ano +" HORA:"+FechaFor, Toast.LENGTH_LONG);
						toast2.show();
						Log.i("Calendario","cita realizada");
			    	  }
			    } 
		    	finish();
		        Intent myIntent = new Intent(Calendario.this, Selcita.class);
		        myIntent.putExtra("usuario_id",r_id_usuario);
	        	myIntent.putExtra("usuario_nombre",r_id_nombre );
	        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
	        	startActivityForResult(myIntent, 0);
		        
	      }

	      }

		});
    	}
   	 	else
   	 	{
   	 		informacion.setText("CONEXION DE DATOS - INCORRECTA");

   	 	}
		
	 Button salida = (Button) findViewById(R.id.calhorario_B_salida);
		 salida.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	finish();		        	
		            Intent myIntent = new Intent(view.getContext(), Selcita.class);
		            myIntent.putExtra("usuario_id",r_id_usuario);
		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        	myIntent.putExtra("medico_id",r_id_medico );
		        	myIntent.putExtra("centro_nombre",r_id_centro_medicos );
			    	myIntent.putExtra("medico_nombre",r_nombre_medico );
			    	startActivityForResult(myIntent, 0);
		        	}
		    	});

	}
}
