package com.example.gesmec;

import java.util.ArrayList;
import java.util.Vector;
import org.json.JSONException;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.app.Activity;
import android.widget.Button;
import android.content.Context;
import android.content.Intent;

/*
 *   Seleccion de datos entre los listados de centros medicos, especialidades y medicos.
 */

public class Cita extends Activity {
	
	ListView listcentros;
	ListView listespecialidades;
	ListView listmedicos;

	String Seleccion="";
	long idrecupera;

	JSONParser json = new JSONParser(this);
	String r_id_nombre, r_nombre_medico;
	long r_id_medicos, r_id_usuario, r_id_centro_medicos, r_id_especialidad, r_id_medico;
	
	Vector<OCentromedico> Vcentromedico = new Vector<OCentromedico>();
	Vector <OMedico> Vmedico = new Vector <OMedico>();
	Vector<OEspecialidad> Vespecialidad = new Vector<OEspecialidad>();
	
	
	ArrayList<String> itemsc = new ArrayList<String>();
	ArrayList<String> itemse = new ArrayList<String>();
	ArrayList<String> itemsm = new ArrayList<String>();
	boolean conexion;
	TextView informacion;
	
	public boolean isOnline() {
		// Comprueba si tiene servicio de conexion 
		 ConnectivityManager cm = 
		         (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo netInfo = cm.getActiveNetworkInfo();
		    if (netInfo != null && netInfo.isConnected()) {
		        return true;
		    }
		    return false;
		
	}
		
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.cita);
			
		Bundle datos = getIntent().getExtras ();
		//recupera los datos enviados desde la clase Selcita
		if (datos != null){
			
			r_id_usuario = datos.getLong("usuario_id");
			r_id_nombre= datos.getString("usuario_nombre");
			r_id_medicos = datos.getLong("usuario_id_servicio_medico");
			r_nombre_medico = datos.getString("medico_nombre");
		}
		listcentros = (ListView)findViewById(R.id.cita_LV_centromedico);
		listespecialidades = (ListView)findViewById(R.id.cita_LV_especialidad);
		listmedicos = (ListView)findViewById(R.id.cita_LV_medico);	    
		
		informacion = (TextView) findViewById(R.id.datepi_T_informacion);
		conexion = isOnline();
		if (conexion == true)
    	{
   	 		//mostramos informacion
   	 		informacion.setText("CONEXION DE DATOS - CORRECTA");

		
		try {
			Vcentromedico=json.readAndParseJSONgetCentrosMedicosServer(r_id_medicos);
		} catch (JSONException e) {
			Log.e("Cita", "error"+e.toString());
			e.printStackTrace();
			
		}
		
			if (Vcentromedico != null)
			{
				
			      for( int i=0; i<Vcentromedico.size() ; i ++ ){ 
			    	  OCentromedico centromedicor = new OCentromedico();
			    	  centromedicor = Vcentromedico.elementAt(i); 
			    	  itemsc.add(centromedicor.getnombre());
	        			
	        			} 
			}
			else
			{
					Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN CENTRO MEDICO \n Tabla vacia o inexistente", Toast.LENGTH_LONG);
					toast2.show();
					Log.e("Cita", "error en la tabla centro medico");
					
					finish();
					Intent myIntent = new Intent(Cita.this, Selcita.class);
			        
					 myIntent.putExtra("usuario_id",r_id_usuario);
			        	myIntent.putExtra("usuario_nombre",r_id_nombre );
			        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
			        	myIntent.putExtra("centro_nombre",r_id_centro_medicos );
				   
					startActivityForResult(myIntent, 0);
		 	}
 		
		
		listcentros.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_dropdown_item_1line, itemsc));    
	    listcentros.setClickable(true);
	    listcentros.setOnItemClickListener(new AdapterView.OnItemClickListener() {

		      @Override
		      public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {

		    	  Object o = listcentros.getItemAtPosition(position);
			        System.out.println("'o.toString --- "+o.toString());
			        for( int i=0; i<Vcentromedico.size() ; i ++ ){ 
				    	  OCentromedico centromedicor = new OCentromedico();
				    	  centromedicor = Vcentromedico.elementAt(i); 
				    	  if (centromedicor.getnombre().toString().equals(o.toString()))
				    	  {  r_id_centro_medicos = centromedicor.getid();
		      			  }
			        }
			        // recupera especilidades correspondientes al centro medico
			        try {
						Vespecialidad=json.readAndParseJSONgetVecEspMedServer(r_id_centro_medicos);
					} catch (JSONException e) {
						Log.e("cita", "error "+e.toString());
						e.printStackTrace();
					}
						if (Vespecialidad != null)	
						{
							
							System.out.println("'Vespecialidad.size() --- "+Vespecialidad.size());
							
						    for (int ii=0; ii<Vespecialidad.size(); ii ++ ) {
						    	  OEspecialidad oespecialidad = new OEspecialidad();
						    	  oespecialidad = Vespecialidad.elementAt(ii); 
						    		itemse.add(oespecialidad.getnombre());
									}
						    
						    listespecialidades.setAdapter(new ArrayAdapter<String>(Cita.this, android.R.layout.simple_dropdown_item_1line, itemse));    
							
						}
						else
						{
								Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN ESPECIALIDADES \n Tabla vacia o inexistente", Toast.LENGTH_LONG);
								toast2.show();
								Log.e("cita", "error en la tabla especialidades");
								
								finish();
								Intent myIntent = new Intent(Cita.this, Selcita.class);
								myIntent.putExtra("usuario_id",r_id_usuario);
						        myIntent.putExtra("usuario_nombre",r_id_nombre );
						        myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
						        myIntent.putExtra("centro_nombre",r_id_centro_medicos );
							   startActivityForResult(myIntent, 0);
					 	}
			 	
		      }
			});
		listespecialidades.setClickable(true);
		listespecialidades.setOnItemClickListener(new AdapterView.OnItemClickListener() {

			      @Override
			      public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {

			    	  Object o = listespecialidades.getItemAtPosition(position);
				        for( int i=0; i<Vespecialidad.size() ; i ++ ){ 
					    	  OEspecialidad oespecialidad = new OEspecialidad();
					    	  oespecialidad = Vespecialidad.elementAt(i); 
					    	  if (oespecialidad.getnombre().toString().equals(o.toString()))
					    	  {r_id_especialidad = oespecialidad.getid();
			      			  }
				        }
						//Cargamos un array con la consulta generada
						//Vmedico = BD.getVecMedCenEspServer(r_id_centro_medicos, r_id_especialidad);
						
						try {
							Vmedico=json.readAndParseJSONgetVecMedCenEspServer(r_id_centro_medicos, r_id_especialidad);
						} catch (JSONException e) {
							Log.e("cita", "error "+e.toString());
							
							e.printStackTrace();
						}
						
							if (Vmedico != null)	
							{
							    for (int ii=0; ii<Vmedico.size(); ii ++ ) {
							    	  OMedico omedico = new OMedico();
							    	  omedico = Vmedico.elementAt(ii); 
										itemsm.add(omedico.getnombre());
					        			}
							    
							    listmedicos.setAdapter(new ArrayAdapter<String>(Cita.this, android.R.layout.simple_dropdown_item_1line, itemsm));    
								
							}
							else
							{
									Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN MEDICOS \n Tabla vacia o inexistente", Toast.LENGTH_LONG);
									toast2.show();
									Log.e("cita", "error en la tabla medicos");
									
									finish();
									Intent myIntent = new Intent(Cita.this, Selcita.class);							        
									myIntent.putExtra("usuario_id",r_id_usuario);
							        myIntent.putExtra("usuario_nombre",r_id_nombre );
							        myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
							        myIntent.putExtra("centro_nombre",r_id_centro_medicos );
									startActivityForResult(myIntent, 0);
						 	}
			        
			      }

		    });

		listmedicos.setClickable(true);		
		listmedicos.setOnItemClickListener(new AdapterView.OnItemClickListener() {

			      @Override
			      public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {

			        Object o = listmedicos.getItemAtPosition(position);
			        for( int i=0; i<Vmedico.size() ; i ++ ){ 
				    	  OMedico omedico = new OMedico();
				    	  omedico = Vmedico.elementAt(i); 
				    	  if (omedico.getnombre().toString().equals(o.toString()))
				    	  { 
				    		  r_id_medico = omedico.getid();
				    	  	  r_nombre_medico = omedico.getnombre().toString();
				    	  }
		      				
			        }
			        finish();
			        Intent myIntent = new Intent(Cita.this, Selhorario.class);
 		            myIntent.putExtra("usuario_id",r_id_usuario);
 		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
 		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
 		        	myIntent.putExtra("medico_id",r_id_medico );
 		        	myIntent.putExtra("medico_nombre",r_nombre_medico );
 		        	startActivityForResult(myIntent, 0);  	
	    				
		        }
		    });
    	}
   	 	else
   	 	{
   	 		informacion.setText("CONEXION DE DATOS - INCORRECTA");

   	 	}
		Button atras = (Button) findViewById(R.id.cita_B_salida);
		 atras.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	finish();
		            Intent myIntent = new Intent(view.getContext(), Selcita.class);
		            myIntent.putExtra("usuario_id",r_id_usuario);
 		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
 		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
 		        	myIntent.putExtra("medico_id",r_id_medico );
 		        	myIntent.putExtra("medico_nombre",r_nombre_medico );	       
		            startActivityForResult(myIntent, 0);
		        	}
		    	});
	}
	
			   		    
}
			    
			   
