package com.example.gesmec;

import java.io.IOException;
import java.util.List;
import android.graphics.drawable.Drawable;
import com.example.gesmec.R;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.OverlayItem;
import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AutoCompleteTextView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.Button;
import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.view.KeyEvent;
import com.google.android.maps.ItemizedOverlay;
import java.util.ArrayList;
import java.util.Locale;
import org.json.JSONException;

/*
 * Muestra en detalle la informacion sobre el centro medico asi como su posicionamiento.
 */



public class Detallelista extends MapActivity {
	JSONParser json = new JSONParser(this);
	ListView list;
	AutoCompleteTextView edit ;
	String Seleccion="";
	long idrecupera;
	long r_id_medicos, r_id_usuario, r_id_centro_medicos;
	String r_id_nombre;
	OCentromedico ocentromedico = new OCentromedico();
	MapView map=null;
	MyLocationOverlay me=null;
	
	
	LocationManager manager;
	LocationListener listener;
	MapController control;
	Location location;
	LocationManager locationManager;	
	int ilat; 
	int ilon;
	boolean conexion;
	TextView informacion;
	
	
	public boolean isOnline() {
		// Comprueba si tiene servicio de conexion 
		 ConnectivityManager cm = 
		         (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo netInfo = cm.getActiveNetworkInfo();
		    if (netInfo != null && netInfo.isConnected()) {
		        return true;
		    }
		    return false;
		
	}
  		protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.detallelista);
		
		
		Bundle datos = getIntent().getExtras ();
		if (datos != null){
			r_id_usuario = datos.getLong("usuario_id");
			r_id_nombre= datos.getString("usuario_nombre");
			r_id_medicos = datos.getLong("usuario_id_servicio_medico");
			r_id_centro_medicos = datos.getLong("centro_nombre");
		}
		TextView Campos = (TextView)findViewById(R.id.detallelista_T_campos);
		TextView Detalles = (TextView)findViewById(R.id.detallelista_T_datos);
		informacion = (TextView)findViewById(R.id.detallelista_T_informacion);
		ocentromedico=null;
		conexion = isOnline();
		if (conexion == true)
    	{
   	 		//mostramos informacion
   	 		informacion.setText("CONEXION DE DATOS - CORRECTA");

		
		try {
			ocentromedico=json.readAndParseJSONgetCentroMedicoidServer(r_id_centro_medicos);
		} catch (JSONException e) {
			Log.e("Detallelista","error e"+e.toString());
			e.printStackTrace();
		}
	
		if (ocentromedico != null)
			
			{
				Campos.setText("NOMBRE:"+
					      "\nDIRECCION:"+
					      "\nTELEFONO:"+
					      "\nLONGITUD:"+
					      "\nLATITUD:"+
					      "\nCODIGO POSTAL:"+
					      "\nOBSERVACIONES:");

			Detalles.setText(ocentromedico.getnombre()+
				      "\n"+ocentromedico.getdireccion()+
				      "\n"+ocentromedico.gettelefono()+
				      "\n"+ocentromedico.getlongitud()+
				      "\n"+ocentromedico.getlatitud()+
				      "\n"+ocentromedico.getcodigo_postal()+
				      "\n"+ocentromedico.getobservaciones());
					map=(MapView)findViewById(R.id.map);
				    
				    //posiciona la latitud y longitud en el mapa  
					map.getController().setCenter(getPoint(Double.parseDouble(ocentromedico.getlatitud()), Double.parseDouble(ocentromedico.getlongitud())));
				    map.getController().setZoom(17);
				    //activamos la opcion de zoom
				    map.setBuiltInZoomControls(true);
				    
				    
				    Drawable marker=getResources().getDrawable(R.drawable.images);
				    marker.setBounds(0, 0, marker.getIntrinsicWidth(),
				                            marker.getIntrinsicHeight());
				    
				    map.getOverlays().add(new SitesOverlay(marker));
				    
				    me=new MyLocationOverlay(this, map);
				    map.getOverlays().add(me);

			}
			else 
			{
				Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN CENTRO MEDICO \n Tabla vacia o inexistente", Toast.LENGTH_SHORT);
				toast2.show();
				Log.e("Detallelista","error en centro medico tabla vacia o inexistente");
				finish();
				Intent myIntent = new Intent(Detallelista.this, Seleccion.class);
				myIntent.putExtra("usuario_id",r_id_usuario);
				myIntent.putExtra("usuario_nombre",r_id_nombre );
				myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
				myIntent.putExtra("centro_nombre",r_id_centro_medicos );
				startActivityForResult(myIntent, 0);
			}
    	}
   	 	else
   	 	{
   	 		informacion.setText("CONEXION DE DATOS - INCORRECTA");

   	 	}
	 		

			Button localizacion = (Button) findViewById(R.id.detalle_B_localizacion);
			localizacion.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	  
					    locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);
				 	
					    Criteria criteria = new Criteria();
					    criteria.setAccuracy(Criteria.ACCURACY_FINE);
					    criteria.setAltitudeRequired(false);
					    criteria.setBearingRequired(false);
					    criteria.setCostAllowed(true);
					    criteria.setPowerRequirement(Criteria.POWER_LOW);
						
					    String provider = locationManager.getBestProvider(criteria, true);
						location = locationManager.getLastKnownLocation(provider);
						updateWithNewLocation(location);
						locationManager.requestLocationUpdates(provider, 2000, 10,locationListener);
				    	locationManager.removeUpdates(locationListener);
					    

		        	}
		    	});
		    Button salida = (Button) findViewById(R.id.detallelista_B_salida);
		    salida.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	finish();
		        	Intent myIntent = new Intent(view.getContext(), Seleccion.class);
		          	myIntent.putExtra("usuario_id",r_id_usuario);
		          	myIntent.putExtra("usuario_nombre",r_id_nombre );
		          	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		          	startActivityForResult(myIntent, 0);
		        	}
		    	});
		    
		   	}
  		
  		// posicionamiento del dispositivo
  		
  		///
  		private final LocationListener locationListener = new LocationListener() {
  		    public void onLocationChanged(Location location) {
  		      updateWithNewLocation(location);
  		    }

  		    public void onProviderDisabled(String provider) {
  		      updateWithNewLocation(null);
  		    }

  		    public void onProviderEnabled(String provider) {
  		    }

  		    public void onStatusChanged(String provider, int status, Bundle extras) {
  		    }
  		  };

  		  private void updateWithNewLocation(Location location) {
  		    String latLongString;
  		    String addressString = "No se encuentra direccion";
  		    
  		    if (location != null) {
  		    	double lat = location.getLatitude();
  			    double lng = location.getLongitude();
  			    
  		      latLongString = "Latitud:" + lat + "\nLongitud:" + lng;
  		      System.out.println("latLongString"+latLongString);
  			
  		      Geocoder gc = new Geocoder(this, Locale.getDefault());
  		      try {
  		        List<Address> addresses = gc.getFromLocation(lat, lng, 1);
  		        StringBuilder sb = new StringBuilder();
  		        if (addresses.size() > 0) {
  		          Address address = addresses.get(0);

  		          for (int i = 0; i < address.getMaxAddressLineIndex(); i++)
  		            sb.append(address.getAddressLine(i)).append("\n");

  		          sb.append(address.getLocality()).append("\n");
  		          sb.append(address.getPostalCode()).append("\n");
  		          sb.append(address.getCountryName());
  		        }
  		        addressString = sb.toString();
  		        
  		        String XX_calle="Posicion actual del dispositivo:\n" + latLongString+ "\n" + addressString;
  	  		  	  
  		    	final double DEG_RATE = 1000;
  		    	double startLatitude = lat;
  		    	double startLongitude= lng ;
  		    	double endLatitude = Double.parseDouble(ocentromedico.getlatitud());
  		    	double endLongitude= Double.parseDouble(ocentromedico.getlongitud());
  		    	
  		    	float[] result = new float[1];
  		    	Location.distanceBetween(startLatitude, startLongitude, endLatitude, endLongitude, result);
  		    	Toast toast2 = Toast.makeText(getApplicationContext(), " "+XX_calle , Toast.LENGTH_LONG);
  		  		toast2.show();
  		  		informacion.setText("Se encuentra a "+result[0]/DEG_RATE+" Km");
  		  	
  		      } catch (IOException e) {
  		    	  
  		      }
  		    } 
  		    else 
  		    {
  		      latLongString = "No se encuentra localizacion";
  		    }
  		  }
  		// posicionamiento del dispositivo
  	  	
  		  //pinta mapa punto de medico

  		  	  @Override
			  public void onResume() {
			    super.onResume();
			    me.enableCompass();
			  }    
			  @Override
			  public void onPause() {
			    super.onPause();
			    Intent intent = new Intent("android.location.GPS_ENABLED_CHANGE");
			    intent.putExtra("enabled", false);
			    sendBroadcast(intent);
			    me.disableMyLocation();
			    me.disableCompass();
			  }    
			  
			   @Override
			  protected boolean isRouteDisplayed() {
			    return(false);
			  }
			  
			   @Override
			  public boolean onKeyDown(int keyCode, KeyEvent event) {
			    if (keyCode == KeyEvent.KEYCODE_S) {
			      map.setSatellite(!map.isSatellite());
			      return(true);
			    }
			    else if (keyCode == KeyEvent.KEYCODE_Z) {
			      map.displayZoomControls(true);
			      return(true);
			    }
			    
			    return(super.onKeyDown(keyCode, event));
			  }

			  private GeoPoint getPoint(double lat, double lon) {
			    return(new GeoPoint((int)(lat*1000000.0),(int)(lon*1000000.0)));
			  }
			    
			  private class SitesOverlay extends ItemizedOverlay<OverlayItem> {
			    private List<OverlayItem> items=new ArrayList<OverlayItem>();
			    private Drawable marker=null;
			    
			    public SitesOverlay(Drawable marker) {
			      super(marker);
			      this.marker=marker;
			      //pinta el posicionamiento en el overlay del mapa
			      items.add(new OverlayItem(getPoint(Double.parseDouble(ocentromedico.getlatitud()), Double.parseDouble(ocentromedico.getlongitud())),
			    		  ocentromedico.getnombre(), ocentromedico.getnombre()));
				      populate();
			    }
			    
			    @Override
			    protected OverlayItem createItem(int i) {
			      return(items.get(i));
			    }
			    
			    @Override
			    public void draw(Canvas canvas, MapView mapView, boolean shadow) {
			      super.draw(canvas, mapView, shadow);
			      boundCenterBottom(marker);
			    }
			     
			    @Override
			    protected boolean onTap(int i) {
			      Toast.makeText(getApplicationContext(),items.get(i).getSnippet(),Toast.LENGTH_SHORT).show();
			      return(true);
			    }
			    
			    @Override
			    public int size() {
			      return(items.size());
			    }
			  
			  }

	  		  //pinta mapa punto de medico
			}
		