package com.example.gesmec;

import java.util.ArrayList;
import java.util.Vector;
import org.json.JSONException;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.app.Activity;
import android.widget.Button;
import android.content.Context;
import android.content.Intent;

/*
 * Carga el listado de centros medicos en un objeto lista
 */
public class Lista extends Activity implements TextWatcher{
	Spinner spinner_servmedicos; 
	ListView list;
	AutoCompleteTextView edit ;
	String Seleccion="";
	long idrecupera;
	Vector<OCentromedico> Vcentromedico = new Vector<OCentromedico>();
	TextView informacion;
	
	long r_id_medicos, r_id_usuario, r_id_centro_medicos;
	String r_id_nombre ;
	JSONParser json = new JSONParser(this);
	boolean conexion;
	
	public boolean isOnline() {
		// Comprueba si tiene servicio de conexion 
		 ConnectivityManager cm = 
		         (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo netInfo = cm.getActiveNetworkInfo();
		    if (netInfo != null && netInfo.isConnected()) {
		        return true;
		    }
		    return false;
		
	}
	
	 
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.lista);
		
		Bundle datos = getIntent().getExtras ();
		if (datos != null){			
			r_id_usuario = datos.getLong("usuario_id");
			r_id_nombre= datos.getString("usuario_nombre");
			r_id_medicos = datos.getLong("usuario_id_servicio_medico");				
		}
		
		
		list = (ListView)findViewById(R.id.lista_LT_centros);
		
		//Cargamos un array con la consulta generada
		ArrayList<String> items = new ArrayList<String>();
		
		informacion = (TextView)findViewById(R.id.detallelista_T_informacion);
		conexion = isOnline();
		if (conexion == true)
    	{
   	 		//mostramos informacion
   	 		informacion.setText("CONEXION DE DATOS - CORRECTA");

		
		try {
			Vcentromedico=json.readAndParseJSONgetCentrosMedicosServer(r_id_medicos);
		} catch (JSONException e) {
			Log.e("Lista","error e"+e.toString());
			e.printStackTrace();
		}
		
		
		if (Vcentromedico != null)
		{
		      for( int i=0; i<Vcentromedico.size() ; i ++ ){ 
		    	  OCentromedico centromedicor = new OCentromedico();
		    	  centromedicor = Vcentromedico.elementAt(i); 
        			items.add(centromedicor.getnombre());
        			} 
		}
		else
		{
				Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR EN CENTROS MEDICO \n SE HA PRODUCIDO ALGUN ERROR EN LA BBDD", Toast.LENGTH_SHORT);
				toast2.show();
				Log.e("Lista","error en centros medicos");
				finish();
				//finaliza este activity
				Intent myIntent = new Intent(Lista.this, Seleccion.class);
				myIntent.putExtra("usuario_id",r_id_usuario);
		        myIntent.putExtra("usuario_nombre",r_id_nombre );
		        myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        myIntent.putExtra("centro_nombre",r_id_centro_medicos );
		        startActivityForResult(myIntent, 0);
	 	}
 		
		
		//carga el cuadro de texto con la lista
		edit = (AutoCompleteTextView)findViewById(R.id.lista_ACTV_busCentro);
		edit.addTextChangedListener(this);
		edit.setAdapter(new ArrayAdapter<String>(this,android.R.layout.simple_selectable_list_item, items));
		
		//carga la lista
	    list.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_dropdown_item_1line, items));    	   
	    list.setClickable(true);
	    list.setOnItemClickListener(new AdapterView.OnItemClickListener() {

	      @Override
	      public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {

	        Object o = list.getItemAtPosition(position);
	        for( int i=0; i<Vcentromedico.size() ; i ++ ){ 
		    	  OCentromedico centromedicor = new OCentromedico();
		    	  centromedicor = Vcentromedico.elementAt(i); 
		    	  if (centromedicor.getnombre().toString().equals(o.toString()))
		    		  r_id_centro_medicos = centromedicor.getid();
      			}
	        finish();
	        Intent myIntent = new Intent(Lista.this, Detallelista.class);
	        myIntent.putExtra("usuario_id",r_id_usuario);
        	myIntent.putExtra("usuario_nombre",r_id_nombre );
        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
        	myIntent.putExtra("centro_nombre",r_id_centro_medicos );
        	startActivityForResult(myIntent, 0);
	        
	      }

		});
    	}
		else
   	 	{
   	 		informacion.setText("CONEXION DE DATOS - INCORRECTA");

   	 	}
	 		

	Button buscar = (Button) findViewById(R.id.lista_B_buscar);
    buscar.setOnClickListener(new View.OnClickListener() {
        public void onClick(View view) {       	
        	   for( int i=0; i<Vcentromedico.size() ; i ++ ){ 
 		    	  OCentromedico centromedicor = new OCentromedico();
 		    	  centromedicor = Vcentromedico.elementAt(i); 
 		    	  if (centromedicor.getnombre().toString().equals( edit.getText().toString()))
 		    		  r_id_centro_medicos = centromedicor.getid();
 					
       			}
        	finish();
 	        Intent myIntent = new Intent(Lista.this, Detallelista.class);
 	        myIntent.putExtra("usuario_id",r_id_usuario);
         	myIntent.putExtra("usuario_nombre",r_id_nombre );
         	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
         	myIntent.putExtra("centro_nombre",r_id_centro_medicos );
         	startActivityForResult(myIntent, 0);
        	  
        }
    	});
    
    Button atras = (Button) findViewById(R.id.lista_B_salida);
    atras.setOnClickListener(new View.OnClickListener() {
        public void onClick(View view) {
        	finish();       	
        	Intent myIntent = new Intent(view.getContext(), Seleccion.class);
        	myIntent.putExtra("usuario_id",r_id_usuario);
        	myIntent.putExtra("usuario_nombre",r_id_nombre );
        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );       	
        	startActivityForResult(myIntent, 0);
            
        	}
    	});
  
	}




	@Override
	public void afterTextChanged(Editable s) {
		// TODO Auto-generated method stub
		
		Seleccion=edit.getText().toString();
		
	}




	@Override
	public void beforeTextChanged(CharSequence s, int start, int count,
			int after) {
		// TODO Auto-generated method stub
		
	}




	@Override
	public void onTextChanged(CharSequence s, int start, int before, int count) {
		// TODO Auto-generated method stub
		
		
	}
}
