package com.example.gesmec;

import java.util.ArrayList;
import java.util.Vector;
import org.json.JSONException;

import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.app.Activity;
import android.widget.Button;
import android.content.Context;
import android.content.Intent;

/*
 * Muestra el listado de historico de citas en un objeto lista
 */

public class Listacita extends Activity{
	Spinner spinner_servmedicos; 
	ListView list;
	String Seleccion="";
	long idrecupera;
	Vector<OCita> Vcita = new Vector<OCita>();
	JSONParser json3 = new JSONParser(this);
	
	long r_id_medicos, r_id_usuario, r_id_centro_medicos;
	String r_id_nombre ;
	
	boolean conexion;
	TextView informacion;
	

	public boolean isOnline() {
		// Comprueba si tiene servicio de conexion 
		 ConnectivityManager cm = 
		         (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo netInfo = cm.getActiveNetworkInfo();
		    if (netInfo != null && netInfo.isConnected()) {
		        return true;
		    }
		    return false;
		
	}
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.listacita);
		
		Bundle datos = getIntent().getExtras ();
		if (datos != null){
			
			r_id_usuario = datos.getLong("usuario_id");
			r_id_nombre= datos.getString("usuario_nombre");
			r_id_medicos = datos.getLong("usuario_id_servicio_medico");
				
		}
		
		
		list = (ListView)findViewById(R.id.listacita_LT_citas);
		
		//Cargamos un array con la consulta generada
		ArrayList<String> items = new ArrayList<String>();
		informacion = (TextView)findViewById(R.id.listacita_T_informacion);
		conexion = isOnline();
		if (conexion == true)
    	{
   	 		//mostramos informacion
   	 		informacion.setText("CONEXION DE DATOS - CORRECTA");
		
		try {
			Vcita=json3.readAndParseJSONgetListaCitaServer(r_id_usuario);
		} catch (JSONException e) {
			Log.e("listacita", "error  "+e.toString());					  		
			e.printStackTrace();
		}
		
		if (Vcita != null)
		{
		      for( int i=0; i<Vcita.size() ; i ++ ){ 
		    	  OCita citar = new OCita();
		    	  citar = Vcita.elementAt(i); 
		    	  
		    	  //Formateamos la fecha para su correcta visualizacion
		    	 	String s_hora= String.valueOf(citar.getid_hora());
		    		String s_formateohora="";
				   if (s_hora.length() ==3)
				   {s_formateohora='0'+s_hora.substring(0, 1)+':'+s_hora.substring(1, 3);} 
				   else 
				   {
					   if (s_hora.length() == 4){
						   s_formateohora=s_hora.substring(0, 2)+':'+s_hora.substring(2, 4);} 
					   
					   else{
							Toast toast2 = Toast.makeText(getApplicationContext(), "ERROR FORMATO HORA ", Toast.LENGTH_SHORT);
							toast2.show();
							Log.e("Listacita","error en el formato de hora");
					   }
				   }
        			items.add("D: "+citar.getid_fecha()+" H: " + s_formateohora + "\n Dr: "+ citar.getnombre_medico());
        			} 
		}
		else
		{
				Toast toast2 = Toast.makeText(getApplicationContext(), "NO EXISTE HISTORICO DE CITAS PARA USTED ", Toast.LENGTH_SHORT);
				toast2.show();
				Log.i("Listacita","No existe historico de citas");
	 	}

		list.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_expandable_list_item_1, items));    
    	list.setClickable(false);
    	}
   	 	else
   	 	{
   	 		informacion.setText("CONEXION DE DATOS - INCORRECTA");

   	 	}
		
    	Button atras = (Button) findViewById(R.id.listacita_B_salida);
	    atras.setOnClickListener(new View.OnClickListener() {
	        public void onClick(View view) {
	        	finish();	        	
	        	Intent myIntent = new Intent(view.getContext(), Selcita.class);
	        	myIntent.putExtra("usuario_id",r_id_usuario);
	        	myIntent.putExtra("usuario_nombre",r_id_nombre );
	        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
	        	startActivityForResult(myIntent, 0);
	            
	        	}
	    	});
	}
  
}

