package com.example.gesmec;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.app.Activity;
import android.widget.Button;
import android.content.Intent;
import java.util.Calendar;


/*
 * Pantalla de seleccion entre los diferentes tipos de seleccion de horarios (hoy o fecha).
 */
public class Selhorario extends Activity {
	long r_id_medicos, r_id_usuario, r_id_medico;
	String r_id_nombre, r_nombre_medico;
	OUsuario ousuario;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.selhorario);
		ousuario = new OUsuario();
		
		Bundle datos = getIntent().getExtras ();
		
		if (datos != null){
				r_id_usuario = datos.getLong("usuario_id");
				r_id_nombre = datos.getString("usuario_nombre");
				r_id_medicos = datos.getLong("usuario_id_servicio_medico");
				r_id_medico= datos.getLong("medico_id");
				r_nombre_medico = datos.getString("medico_nombre");
				TextView controlTexto = (TextView) findViewById(R.id.selhora_T_nombre);
				controlTexto.setText(r_nombre_medico);
		}
			
		 Button hoy = (Button) findViewById(R.id.selhora_B_hoy);
		 hoy.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	int ano, mes, dia;
		        	 Calendar today = Calendar.getInstance();
		 		    ano = today.get(Calendar.YEAR);
		 		    mes = today.get(Calendar.MONTH)+1;
		 		    //Formatea el mes para que tenga dos digitos.
		 		    dia = today.get(Calendar.DAY_OF_MONTH);
		 		
		 		    finish();
		        	Intent myIntent = new Intent(view.getContext(), Calendario.class);
		            myIntent.putExtra("usuario_id",r_id_usuario);
		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        	myIntent.putExtra("medico_id",r_id_medico );
		        	myIntent.putExtra("dia",dia );
 		        	myIntent.putExtra("mes",mes );
 		        	myIntent.putExtra("ano",ano );
 		        	myIntent.putExtra("medico_nombre",r_nombre_medico );
 		          	startActivityForResult(myIntent, 0);
		        	}
		    	});
		 
		 Button calendario = (Button) findViewById(R.id.selhora_B_dia);
		 calendario.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	finish();		        	
		            Intent myIntent = new Intent(view.getContext(), datepi.class);
		            myIntent.putExtra("usuario_id",r_id_usuario);
		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        	myIntent.putExtra("medico_id",r_id_medico );
		        	myIntent.putExtra("medico_nombre",r_nombre_medico ); 		        	
		            startActivityForResult(myIntent, 0);
		        	}
		    	});
		
		 Button salida = (Button) findViewById(R.id.selhora_B_salida);
		 salida.setOnClickListener(new View.OnClickListener() {
		        public void onClick(View view) {
		        	finish();	        	
		            Intent myIntent = new Intent(view.getContext(), Cita.class);
		            myIntent.putExtra("usuario_id",r_id_usuario);
		        	myIntent.putExtra("usuario_nombre",r_id_nombre );
		        	myIntent.putExtra("usuario_id_servicio_medico",r_id_medicos );
		        	myIntent.putExtra("medico_id",r_id_medico );
		        	myIntent.putExtra("medico_nombre",r_nombre_medico );		        	
		            startActivityForResult(myIntent, 0);
		        	}
		    	});
	}
}
